#include "/usr/include/fftw3.h"
#include "ffthandler.h"
#include <iostream>
#include <math.h>

FFTHandler::FFTHandler(int N) {
    in = (fftw_complex *) fftw_malloc(sizeof(fftw_complex)*N);
    out = (fftw_complex *) fftw_malloc(sizeof(fftw_complex)*N);
    out_fft = (double*) malloc(sizeof(double)*(N/2));
    points = N;
}

double *FFTHandler::computeFFT(short *data){
    populate(data);
    p = fftw_plan_dft_1d(points, in, out, FFTW_FORWARD, FFTW_ESTIMATE);
    fftw_execute(p);
    fftw_destroy_plan(p);

    for(int i = 0; i < points/2; i++)
        out_fft[i] = sqrt(pow(out[i][0],2) + pow(out[i][1],2))/points;

    return out_fft;
}

void FFTHandler::populate(short *data){
    for(int i = 0; i < points; i++){
        in[i][0] = data[i];
        in[i][1] = 0;
    }
}

void FFTHandler::changeFFTPoints(int points){

    // We use realloc to reallocate the previous and contiguous
    // memory usage of the fft

    //this->points = points;
    //in_fft = (double *) realloc(in_fft, points);
    //out_fft = (double *) realloc(in_fft, points);

}

int FFTHandler::getPoints(){
    return points;
}

QVector <double> * FFTHandler::getPeaks(double *arr, int size, int threshold){
    double diff = 0;
    peaks.clear();

    for(int i = 0; i < (size-1)/2; i++){
        diff = abs(arr[i+2]) + abs(arr[i]) - 2*abs(arr[i+1]);
        if(diff>threshold)
            peaks.append(i);
    }
    return &peaks;

}
