#ifndef FFTHANDLER_H
#define FFTHANDLER_H
#include "/usr/include/fftw3.h"
#include <QVector>
class FFTHandler {
public:
    FFTHandler(int N);

    double *computeFFT(short *data);
    int getPoints();
    void populate(short *data);
    void changeFFTPoints(int points);
    QVector <double> * getPeaks(double *arr, int size, int threshold);

private:
    int points;
    double *out_fft;

    fftw_plan p;
    fftw_complex *in, *out;
    QVector<double> peaks;

};

#endif /* FFTHANDLER_H */

