#ifndef TUNER_H
#define TUNER_H
#include <stdlib.h>
#include <QMainWindow>
#include "ffthandler.h"
#include "micmanager.h"
#include "notemanager.h"



namespace Ui {
/**
 * @brief Clase que contiene la interfaz gráfica
 */
class Tuner;
}

class Tuner : public QMainWindow
{
    Q_OBJECT
public:
    explicit Tuner(FFTHandler *fft, MicManager *mic, QRect dim, QWidget *parent = 0);
    void changeData();


private slots:
    void reDrawPlot();

    void on_showSpectreRadioButton_clicked(bool checked);

    void on_showSignalRadioButton_clicked(bool checked);

    void on_action64_triggered(bool checked);

    void on_checkBox_clicked(bool checked);

private:
    Ui::Tuner *ui;
    QVector<double> data_spectre_x;
    QVector<double> data_spectre_y;
    QVector<double> data_signal_x;
    QVector<double> data_signal_y;
    QVector<double> data_spectre_y_max;

    FFTHandler *fftHandler;
    MicManager *micManager;
    DSPManager *dspman;
    NoteManager *noteman;

    void makePlot();
    void initializeSpectralPlot();
    void initializeSignalPlot();
    void initializeAxis();
    void initializeTimer(int intrval);

    int buffer_size = 256;
};

#endif // TUNER_H
